/*
 * Request.java
 *
 * Created on 13 mai 2002
 */
 
/** Class Request <p>
 * This class allows a request to be represented and handled
 * Company:      ONERA/DCSD/CD<p>
 * @author Matthieu Lombard mlombard@operamail.com
 * @version 0.0
 * @see Request
 * @see InstanceProblem#mRequest
 * @see Strip
 */

import java.util.*;

public class Request {

//-----------------------------------------------------------------------------------
//*******************            A T T R I B U T E S            *********************
//-----------------------------------------------------------------------------------
  
  //read attributes
  /** request index*/
  protected Integer i;
  /** gain associated with the request : unit gain per square kilometer */
  protected double Gi;
  /** surface of the request in square kilometers */
  protected double Si;
  /** type of the request : 0 for a target, 2 for a polygon */
  protected int Ti;
  /** O in case of a mono request, 1 in case of a stereo request */
  protected boolean Sti;
  
  //computed attributes
  /** total request gain = Gi * Si */
  protected double totalGain;
  /** list of strips associated with this request*/
  protected List Stri;  
  /** acquisition level of the request : a value between 0 and 1.*/
  protected double acquisitionLevel;

 
//-----------------------------------------------------------------------------------
//*******************         C O N S T R U C T O R S            ********************
//----------------------------------------------------------------------------------- 
  //-----------------------------------Request---------------------------------
  public Request ( Integer i,
                   double Gi,
                   double Si,
                   int Ti,
                   boolean Sti){
    this.i   = i  ;
    this.Gi  = Gi ;
    this.Si  = Si ;
    this.Ti  = Ti ;
    this.Sti = Sti;

    this.totalGain = this.Gi * this.Si;
    this.Stri = new ArrayList();
    this.acquisitionLevel = 0.0;
    
  }//Request

}//Request
