/*
 * Strip.java
 *
 * Created on 14 mai 2002
 */
 
/** Class Strip <p>
 * This class allows a strip to be represented and handled
 * Company:      ONERA/DCSD/CD<p>
 * @author Matthieu Lombard mlombard@operamail.com
 * @version 0.0
 * @see InstanceProblem#mRequest
 * @see InstanceProblem
 * @see Strip
 */

import java.util.*;

public class Strip {

//-----------------------------------------------------------------------------------
//*******************            A T T R I B U T E S            *********************
//-----------------------------------------------------------------------------------
  
  //read attributes
  /** index of the strip */
  protected Integer j;
  /** index of the request which the strip comes from*/
  protected Integer Rj;
  /** index of the twin strip in case of a stereo request
   * 0 in case of a mono request */
  protected int Twj;
  /** useful surface of the strip in square kilometers */
  protected double SUj;
  /** duration of the strip acquisition in seconds */
  protected double DUj;
  /** geographic points 0 and 1, i.e. first and second ends of the strip */
  protected GeoPoint geoPoint0, geoPoint1;

  // computed attributes
  /** request associated with the strip*/
  protected Request associatedRequest;
  /** ratio between the surface of the strip and the surface of the associated request*/
  protected double fr;
  /** pair of possible acquisitions of the strip. <br>
   *  the first going from the geographic point 0 to the geographic point 1.<br>
   *  the second going from the geographic point 1 to the geographic point 0.<br>
   */
  protected Image[] cImage = new Image[2];

//-----------------------------------------------------------------------------------
//*******************         C O N S T R U C T O R S            ********************
//-----------------------------------------------------------------------------------
  //-------------------------------------Strip---------------------------------
  public Strip ( Integer j, Integer Rj,   
	           int Twj, double SUj,
	           double DUj,
	           GeoPoint geoPoint0,
	           GeoPoint geoPoint1,
	           Request associatedRequest){
    this.j = j;
    this.Rj = Rj;
    this.Twj = Twj;
    this.SUj = SUj;
    this.DUj = DUj;
    this.geoPoint0 = geoPoint0;
    this.geoPoint1 = geoPoint1;
    this.associatedRequest = associatedRequest;

    this.fr = this.SUj / this.associatedRequest.Si;
    
  }//Strip

}// Strip
